<?php

namespace App\Livewire\Studio\Feature;

use App\Livewire\Forms\Studio\Feature\PerfumeFeatureForm;
use App\Models\PerfumeFeature as PerfumeFeatureModel;
use App\Traits\WithAuthorization;
use App\Traits\WithCloseModal;
use App\Traits\WithConfirmation;
use App\Traits\WithToast;
use App\Traits\WithUpdatedData;
use Flux\Flux;
use Livewire\Attributes\On;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('Keunggulan Parfum')]
class PerfumeFeature extends Component
{
    use WithAuthorization, WithCloseModal, WithConfirmation, WithToast, WithUpdatedData;

    public PerfumeFeatureForm $form;

    public string $method = 'create';

    public string $modalTitle = '';

    #[On('modal:open')]
    public function openModal(string $method, string $modalTitle, ?string $id = null)
    {
        $this->resetValidation();
        $this->resetErrorBag();

        $this->method = $method;
        $this->modalTitle = $modalTitle;

        if ($id) {
            $this->form->setPerfumeFeature(PerfumeFeatureModel::byHashOrFail($id));
        }
    }

    public function create()
    {
        $this->canOrAbort('create perfume feature');

        $this->form->store();

        $this->dispatch('refreshDatatable');

        $this->toast('Keunggulan parfum berhasil ditambahkan.');

        Flux::modals()->close();
    }

    public function update()
    {
        $this->canOrAbort('update perfume feature');

        $this->form->update();

        $this->dispatch('refreshDatatable');

        $this->toast('Keunggulan parfum berhasil diperbarui.');

        Flux::modals()->close();
    }

    public function delete(PerfumeFeatureModel $perfumeFeature)
    {
        $this->form->perfumeFeature = $perfumeFeature;

        $this->form->delete();

        $this->dispatch('refreshDatatable');

        $this->toast('Keunggulan parfum berhasil dihapus.');

        Flux::modals()->close();
    }

    #[On('fn:sortOrder')]
    public function sortOrder(PerfumeFeatureModel $perfumeFeature, string $direction)
    {
        $this->canOrAbort('update perfume feature');

        $this->form->perfumeFeature = $perfumeFeature;

        $this->form->sortOrder($direction);

        $this->dispatch('refreshDatatable');
    }

    public function render()
    {
        return view('livewire.studio.feature.perfume-features', [
            'pageTitle' => 'Keunggulan Parfum',
        ]);
    }
}
